import tkinter as tk
from tkinter import ttk, filedialog

import crypt
from crypt import *

from cryptography.hazmat.backends import default_backend
from cryptography.hazmat.primitives import serialization
from cryptography.hazmat.primitives.asymmetric.utils import decode_dss_signature

def on_tab_selected(event):
    selected_tab = tab_control.index(tab_control.select())
    print(f"-\n Selected tab: {selected_tab}\n-")
    label_signed.config(text="")
    label_verify.config(text="")
    label_encrypted.config(text="")


def option_menu_curve_select(event):
    print(f"-\n Selected curve option: {selected_option_curve.get()}\n-")


def option_menu_curve_select_encrypt(event):
    print(f"-\n Selected curve option: {selected_option_curve_encrypt.get()}\n-")


def option_menu_hash_select(event):
    print(f"-\nSelected hash option: {selected_option_hash.get()}\n-")


def option_menu_hash_verify_select(event):
    print(f"-\n Selected hash option: {selected_option_hash_verify.get()}\n-")


def option_menu_hash_select_encrypt(event):
    print(f"-\n Selected hash option: {selected_option_hash_encrypt.get()}\n-")


def option_menu_curve_select_encrypt(event):
    print(f"-\n Selected curve option: {selected_option_curve_encrypt.get()}\n-")


def option_menu_hash_select_encrypt(event):
    print(f"-\n Selected hash option: {selected_option_hash_encrypt.get()}\n-")

def option_menu_hash_select_decrypt(event):
    print(f"-\n Selected hash option: {selected_option_hash_decrypt.get()}\n-")


def show_in_textbox(text, textbox, disabled=False):
    #Clear existing text
    textbox.config(state='normal')
    textbox.delete("1.0", "end")

    # Insert new text
    textbox.insert("1.0", text)
    if disabled:
        textbox.config(state='disabled')


def button_generate_keys_click():
    # add set curve selected_option_curve.get()
    curve_command = "ec." + selected_option_curve.get() + "()"
    private_key = generate_private_key(eval(curve_command))

    private_key_pem = private_key.private_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PrivateFormat.PKCS8,
        encryption_algorithm=serialization.NoEncryption()
    ).decode()

    public_key_pem = generate_public_key(private_key).public_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PublicFormat.SubjectPublicKeyInfo
    ).decode()

    show_in_textbox(private_key_pem,
                    textbox_private_key, True)
    show_in_textbox(public_key_pem,
                    textbox_public_key, True)
    print("KEYS GENERATED")
    print_keys_info(private_key)


def button_generate_keys_encrypt_click():
    # add set curve selected_option_curve.get()
    curve_command = "ec." + selected_option_curve.get() + "()"
    private_key = generate_private_key(eval(curve_command))

    private_key_pem = private_key.private_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PrivateFormat.PKCS8,
        encryption_algorithm=serialization.NoEncryption()
    ).decode()

    public_key_pem = generate_public_key(private_key).public_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PublicFormat.SubjectPublicKeyInfo
    ).decode()

    show_in_textbox(private_key_pem,
                    textbox_private_key_encrypt, True)
    show_in_textbox(public_key_pem,
                    textbox_public_key_encrypt, True)
    print("KEYS GENERATED")
    print_keys_info(private_key)


def button_generate_keys_encrypt_click():
    # add set curve selected_option_curve.get()
    curve_command = "ec." + selected_option_curve_encrypt.get() + "()"
    private_key = generate_private_key(eval(curve_command))

    private_key_pem = private_key.private_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PrivateFormat.PKCS8,
        encryption_algorithm=serialization.NoEncryption()
    ).decode()

    public_key_pem = generate_public_key(private_key).public_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PublicFormat.SubjectPublicKeyInfo
    ).decode()

    show_in_textbox(private_key_pem,
                    textbox_private_key_encrypt, True)
    show_in_textbox(public_key_pem,
                    textbox_public_key_encrypt, True)

    print("KEYS GENERATED")
    print_keys_info(private_key)


def load_private_key_from_textbox(textbox):
    return serialization.load_pem_private_key(
        textbox.get("1.0", tk.END).encode('utf-8'),
        password=None,
        backend=default_backend()
    )
def button_store_keys_click():
    private_key = load_private_key_from_textbox(textbox_private_key)
    store_keys(private_key)
    print("KEYS STORED")


def button_store_keys_encrypt_click():
    private_key = load_private_key_from_textbox(textbox_private_key_encrypt)
    store_keys(private_key)
    print("KEYS STORED")


def button_store_keys_encrypt_click():
    private_key = load_private_key_from_textbox(textbox_private_key_encrypt)
    store_keys(private_key)
    print("KEYS STORED")


def button_load_private_key_click():
    file_path = filedialog.askopenfilename()
    private_key = load_private_key(file_path)

    private_key_pem = private_key.private_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PrivateFormat.PKCS8,
        encryption_algorithm=serialization.NoEncryption()
    )
    show_in_textbox(private_key_pem, textbox_private_key, disabled=True)
    show_in_textbox("", textbox_public_key, disabled=True)

    print("PRIVATE KEY LOADED")
    print_private_key_info(private_key)


def button_private_key_decrypts_click():
    file_path = filedialog.askopenfilename()
    private_key = load_private_key(file_path)

    private_key_pem = private_key.private_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PrivateFormat.PKCS8,
        encryption_algorithm=serialization.NoEncryption()
    )
    show_in_textbox(private_key_pem, textbox_private_key_decrypt, disabled=True)
    print("PRIVATE KEY LOADED")
    print_private_key_info(private_key)

def button_load_keys_encrypt_click():
    file_path = filedialog.askopenfilename()
    private_key = load_private_key(file_path)

    private_key_pem = private_key.private_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PrivateFormat.PKCS8,
        encryption_algorithm=serialization.NoEncryption()
    )
    show_in_textbox(private_key_pem, textbox_public_key_encrypt, disabled=True)
    public_key_pem = generate_public_key(private_key).public_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PublicFormat.SubjectPublicKeyInfo
    )
    show_in_textbox(public_key_pem, textbox_public_key_encrypt, disabled=True)
    print("PRIVATE KEY LOADED")


def button_load_public_key_encrypt_click():
    file_path = filedialog.askopenfilename()
    public_key = load_public_key(file_path)

    public_key_pem = public_key.public_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PublicFormat.SubjectPublicKeyInfo
    )

    show_in_textbox(public_key_pem, textbox_public_key_encrypt, disabled=True)
    show_in_textbox("", textbox_private_key_encrypt, disabled=True)
    print("PUBLIC KEY LOADED")
    print_public_key_info(public_key)


def button_load_public_key_click():
    file_path = filedialog.askopenfilename()
    public_key = load_public_key(file_path)

    public_key_pem = public_key.public_bytes(
        encoding=serialization.Encoding.PEM,
        format=serialization.PublicFormat.SubjectPublicKeyInfo
    )
    show_in_textbox(public_key_pem, textbox_public_key_sig_verify, disabled=True)
    print("PUBLIC KEY LOADED")
    print_public_key_info(public_key)


def button_load_message_click():
    file_path = filedialog.askopenfilename()

    with open(file_path, "r") as f:
        text = f.read()
        f.close()
    show_in_textbox(text, textbox_message)
    print(f".\n FILE LOADED: : {file_path}\n")
    print(f"MESSAGE: {text}")


def button_load_message_encrypt_click():
    file_path = filedialog.askopenfilename()

    with open(file_path, "r") as f:
        text = f.read()
        f.close()
    show_in_textbox(text, textbox_message_encrypt)
    print(f".\n FILE LOADED: : {file_path}\n-")
    print(f"MESSAGE: {text}")


def button_load_data_click():
    file_path = filedialog.askopenfilename()
    with open(file_path, "rb") as f:
        data = f.read()
        f.close()

    show_in_textbox(data, textbox_data)
    print(f".\n FILE LOADED: : {file_path}\n-")
    print(f"MESSAGE: {data}")


def button_load_encrypt_click():
    file_path = filedialog.askopenfilename()

    show_in_textbox(file_path, textbox_load_encrypted)
    print(f".\n FILE LOADED: : {file_path}\n-")


def button_load_signature_click():
    file_path = filedialog.askopenfilename()

    show_in_textbox(file_path, textbox_load_signature)
    print(f".\n FILE LOADED: : {file_path}\n-")


def show_window_error(error_message):
    window_error = tk.Toplevel(root)
    window_error.title("Error")

    label_error = tk.Label(window_error, text=error_message, padx=20, pady=20)
    label_error.grid(row=0, column=1, padx=10, pady=5)

    button_ok = tk.Button(window_error, text="OK", padx=10, pady=5, command=window_error.destroy)
    button_ok.grid(row=1, column=1, padx=10, pady=5)

    # Get the dimensions of the root window
    root_width = root.winfo_width()
    root_height = root.winfo_height()

    # Get the dimensions of the error window
    error_width = window_error.winfo_width()
    error_height = window_error.winfo_height()

    # Calculate the position to center the error window
    x_position = (root_width - error_width) // 2
    y_position = (root_height - error_height) // 2

    # Set the error window's position
    window_error.geometry(f"+{x_position}+{y_position}")


def button_signature_click():
    message = textbox_message.get("1.0", "end-1c")
    private_key_pem = textbox_private_key.get("1.0", tk.END)
    if message.isspace():
        print("Error: \nMessage is empty")
        show_window_error("Error: \nMessage is empty")

    elif private_key_pem.isspace():
        print("Error: \nKey is empty")
        show_window_error("Error: \nKey is empty")

    else:
        message = message.encode()
        private_key = load_private_key_from_textbox(textbox_private_key)

        hash_command = "hashes." + selected_option_hash.get() + "()"
        signed_data = generate_signature(message, private_key, eval(hash_command))
        r, s = decode_dss_signature(signed_data)
        print(n * '*')
        print(f"MESSAGE: {message.decode()}")
        print(f"Hash: {eval(hash_command).name}")
        print(f"Signed data: {signed_data.hex()}")
        print(f'r: {r}')
        print(f's: {s}')
        print(n * '*')

        label_signed.config(text="Potpisano!")

        # textbox_signed_data = tk.Text(tab1, height=5, width=textbox_width)
        # textbox_signed_data.insert("1.0", signed_data)
        # textbox_signed_data.config(state='disabled')
        # textbox_signed_data.grid(row=8, column=1, columnspan=2, padx=10, pady=5)
        #
        # label_set_curve_hex = tk.Label(tab1, text='Signed data (hex):')
        # label_set_curve_hex.grid(row=9, column=0, padx=10, pady=5)
        #
        # textbox_signed_data_hex = tk.Text(tab1, height=5, width=textbox_width)
        # textbox_signed_data_hex.insert("1.0", signed_data.hex())
        # textbox_signed_data_hex.config(state='disabled')
        # textbox_signed_data_hex.grid(row=9, column=1, columnspan=2, padx=10, pady=5)

        with open("signature.txt", 'wb') as f:
            f.write(signed_data)
            f.close()

        with open("data.txt", 'wb') as f:
            f.write(message)
            f.close()
        print("MESSAGE SIGNED")

def button_verify_signature_click():
    print("-\n Signature verification")
    public_key_pem = textbox_public_key_sig_verify.get("1.0", "end-1c").encode('utf-8')
    public_key = pem_to_public_key(public_key_pem)
    signature_path = textbox_load_signature.get("1.0", "end-1c")

    if public_key_pem.isspace():
        print("Error: \nNo public key")
        show_window_error("Error: \nPlease select public key")

    elif signature_path.isspace():
        print("Error: \nKey is empty")
        show_window_error("Error: \nPlease select signature file path")

    else:

        with open(signature_path, "rb") as signature_file:
            signature = signature_file.read()
            signature_file.close()

        print(f".\n Signature file loaded: {signature_path}\n-")
        print(f"SIGNATURE: {signature}")

        r, s = decode_dss_signature(signature)
        print(f'r: {r}')
        print(f's: {s}')
        print(n * '*')

        data = textbox_data.get("1.0", "end-1c").encode()
        print(f"DATA: {data}")
        print(f"DATA type {type(data)}")

        hash_command = "hashes." + selected_option_hash_verify.get() + "()"
        print(f"Hash: {eval(hash_command).name}")
        verified = verify_signature(public_key, signature, data, eval(hash_command))

        if verified:
            label_verify.config(text= "Verifikacija uspješna !!")
            print(f"Verified: {verified}")
        else:
            label_verify.config(text= "Verifikacija neuspješna !!")
            print(f"Verified: {verified}")

        print(50 * "+")


def button_encrypt_click():

    public_key_pem = textbox_public_key_encrypt.get("1.0", "end-1c").encode('utf-8')
    message = textbox_message_encrypt.get("1.0", "end-1c")
    if public_key_pem.isspace():
        print("Error: \nPublic key is missing")
        show_window_error("Error: \nPublic key is missing")

    elif message.isspace():
        print("Error: \nMessage is missing")
        show_window_error("Error: \nMessage is missing")
    else:
        # print(f"public_key_pem: {public_key_pem}")
        message = textbox_message_encrypt.get("1.0", "end-1c")
        # print(f"message: {message}")

        public_key = pem_to_public_key(public_key_pem)

        hash_command = "hashes." + selected_option_hash_encrypt.get() + "()"

        curve_command = "ec." + selected_option_curve_encrypt.get() + "()"

        encrypted_message = ecies_encrypt(public_key, message, eval(curve_command), hash_command)

        label_encrypted.config(text="Encrypted!!")
        # print(f"Message encrypted: {encrypted_message}")

        with open("encrypted_message.txt", 'wb') as f:
            f.write(encrypted_message)
            f.close()


def button_decrypt_click():
    encrypted_message_path = textbox_load_encrypted.get("1.0", "end-1c")
    private_key_pem = textbox_private_key_decrypt.get("1.0", "end-1c").encode('utf-8')
    print(f"private_key_pem: {private_key_pem}")
    if encrypted_message_path.isspace():
        print("Error: \nNo encrypted file")
        show_window_error("Error: \nNo encrypted file")

    elif private_key_pem.isspace():
        print("Error: \nKey is empty")
        show_window_error("Error: \nKey is empty")

    else:
        private_key = pem_to_private_key(private_key_pem)

        hash_command = "hashes." + selected_option_hash_decrypt.get() + "()"
        with open(encrypted_message_path, 'rb') as f:
            encrypted_message = f.read()
            f.close()
        print(f"encrypted_message: {encrypted_message}")
        print(f"encrypted_message len : {len(encrypted_message)}")
        decrypted_message = ecies_decrypt(private_key, encrypted_message, hash_command)

        print(f"decrypted_message: {decrypted_message}")
        show_in_textbox(decrypted_message, textbox_decrypted)



if __name__ == '__main__':
    n = 30
    textbox_width = 65

    # create window
    root = tk.Tk()
    root.title("ECC")

    tab_control = ttk.Notebook(root)

    # Create 4 tabs
    tab1 = ttk.Frame(tab_control)
    tab2 = ttk.Frame(tab_control)
    tab3 = ttk.Frame(tab_control)
    tab4 = ttk.Frame(tab_control)

    tab_control.add(tab1, text='Digitalni potpis')
    tab_control.add(tab2, text='Verificiraj potpis')
    tab_control.add(tab3, text='Šifriraj poruku')
    tab_control.add(tab4, text='Dešifriraj poruku')

    # tab 1
    row = 0
    label_set_curve = tk.Label(tab1, text='Odaberi krivulju:')
    label_set_curve.grid(row=row, column=1, padx=10, pady=5)

    options = ["SECP224R1", "SECP256R1", "SECP384R1", "SECP521R1", "SECT571K1", "SECT409K1", "SECT283K1", "SECT163R2"]
    selected_option_curve = tk.StringVar(value=options[0])  # Variable to store selected option
    option_menu_curve = tk.OptionMenu(tab1, selected_option_curve, *options, command=option_menu_curve_select)
    option_menu_curve.grid(row=row, column=2, padx=10, pady=5)

    row += 1
    button_generate_keys = ttk.Button(tab1, text='Generiraj ključeve', command=button_generate_keys_click)
    button_generate_keys.grid(row=row, column=0, padx=10, pady=5)

    button_store_keys = ttk.Button(tab1, text='Spremi ključeve', command=button_store_keys_click)
    button_store_keys.grid(row=row, column=1, padx=10, pady=5)

    button_load_private_key = ttk.Button(tab1, text='Učitaj privatni ključ', command=button_load_private_key_click)
    button_load_private_key.grid(row=row, column=2, padx=10, pady=5)

    row += 1
    label_private_key = tk.Label(tab1, text='Privatni ključ:')
    label_private_key.grid(row=row, column=0, padx=10, pady=5)

    textbox_private_key = tk.Text(tab1, height=8, width=textbox_width)
    textbox_private_key.insert("1.0", "")
    textbox_private_key.config(state='disabled')
    textbox_private_key.grid(row=row, column=1, columnspan=2, padx=10, pady=5)

    row += 1
    label_public_key = tk.Label(tab1, text='Javni ključ:')
    label_public_key.grid(row=row, column=0, padx=10, pady=5)

    textbox_public_key = tk.Text(tab1, height=8, width=textbox_width)
    textbox_public_key.insert("1.0", "")
    textbox_public_key.config(state='disabled')
    textbox_public_key.grid(row=row, column=1, columnspan=2, padx=10, pady=5)

    row += 1
    label_set_hash = tk.Label(tab1, text='Odaberi hash funkciju :')
    label_set_hash.grid(row=row, column=1, padx=10, pady=5)

    options = ["SHA224", "SHA256", "SHA384", "SHA512", "SHA3_224", "SHA3_256", "SHA3_384", "SHA3_512"]
    selected_option_hash = tk.StringVar(value=options[0])  # Variable to store selected option
    option_menu_hash = tk.OptionMenu(tab1, selected_option_hash, *options, command=option_menu_hash_select)
    option_menu_hash.grid(row=row, column=2, padx=10, pady=5)

    row += 1
    button_load_message = ttk.Button(tab1, text='Učitaj poruku', command=button_load_message_click)
    button_load_message.grid(row=5, column=2, padx=10, pady=5)

    row += 1
    label_message = tk.Label(tab1, text='Poruka:')
    label_message.grid(row=row, column=0, padx=10, pady=5)

    textbox_message = tk.Text(tab1, height=2, width=textbox_width)
    textbox_message.insert("1.0", "")
    textbox_message.grid(row=row, column=1, columnspan=2, padx=10, pady=5)

    row += 1
    button_signature = ttk.Button(tab1, text='Generiraj potpis', command=button_signature_click)
    button_signature.grid(row=row, column=1, padx=10, pady=5)

    row += 1
    label_signed = tk.Label(tab1, text='')
    label_signed.grid(row=row, column=1, padx=10, pady=5)

    # tab 2
    row = 0

    button_load_signature = ttk.Button(tab2, text='Učitaj digitalni potpis', command=button_load_signature_click)
    button_load_signature.grid(row=row, column=2, padx=10, pady=5)

    row += 1
    label_signature = tk.Label(tab2, text='Potpis:')
    label_signature.grid(row=row, column=0, padx=10, pady=5)

    textbox_load_signature = tk.Text(tab2, height=1, width=textbox_width)
    textbox_load_signature.insert("1.0", "")
    textbox_load_signature.config(state='disabled')
    textbox_load_signature.grid(row=row, column=1, columnspan=2, padx=10, pady=5)

    row += 1
    button_load_data = ttk.Button(tab2, text='Učitaj poruku', command=button_load_data_click)
    button_load_data.grid(row=row, column=2, padx=10, pady=5)

    row += 1

    label_load_data = tk.Label(tab2, text='Poruka:')
    label_load_data.grid(row=row, column=0, padx=10, pady=5)

    textbox_data = tk.Text(tab2, height=3, width=textbox_width)
    textbox_data.insert("1.0", "")
    # textbox_data.config(state='disabled')
    textbox_data.grid(row=row, column=1, columnspan=2, padx=10, pady=5)

    row += 1
    label_set_hash = tk.Label(tab2, text='Odaberi hash funkciju :')
    label_set_hash.grid(row=row, column=1, padx=10, pady=5)

    options = ["SHA224", "SHA256", "SHA384", "SHA512", "SHA3_224", "SHA3_256", "SHA3_384", "SHA3_512"]
    selected_option_hash_verify = tk.StringVar(value=options[0])  # Variable to store selected option
    option_menu_hash_verify = tk.OptionMenu(tab2, selected_option_hash_verify, *options,
                                            command=option_menu_hash_verify_select)
    option_menu_hash_verify.grid(row=row, column=2, padx=10, pady=5)

    row += 1
    button_load_public_key = ttk.Button(tab2, text='Učitaj javni ključ:', command=button_load_public_key_click)
    button_load_public_key.grid(row=row, column=2, padx=10, pady=5)

    row += 1
    label_public_key = tk.Label(tab2, text='Javni ključ:')
    label_public_key.grid(row=row, column=0, padx=10, pady=5)

    textbox_public_key_sig_verify = tk.Text(tab2, height=8, width=textbox_width)
    textbox_public_key_sig_verify.insert("1.0", "")
    textbox_public_key_sig_verify.config(state='disabled')
    textbox_public_key_sig_verify.grid(row=row, column=1, columnspan=2, padx=10, pady=5)

    row += 1
    button_verify_signature = ttk.Button(tab2, text='Verificiraj potpis', command=button_verify_signature_click)
    button_verify_signature.grid(row=row, column=1, padx=10, pady=5)

    row += 1
    label_verify = tk.Label(tab2, text='Verify :')
    label_verify.grid(row=row, column=1, padx=10, pady=5)

    # Tab 3
    row = 0
    label_set_curve_encrypt = tk.Label(tab3, text='Odaberi krivulju:')
    label_set_curve_encrypt.grid(row=row, column=1, padx=10, pady=5)

    options = ["SECP224R1", "SECP256R1", "SECP384R1", "SECP521R1", "SECT571K1", "SECT409K1", "SECT283K1", "SECT163R2"]
    selected_option_curve_encrypt = tk.StringVar(value=options[0])  # Variable to store selected option
    option_menu_curve_encrypt = tk.OptionMenu(tab3, selected_option_curve_encrypt, *options,
                                              command=option_menu_curve_select_encrypt)
    option_menu_curve_encrypt.grid(row=row, column=2, padx=10, pady=5)

    row += 1
    button_generate_keys_encrypt = ttk.Button(tab3, text='Generiraj ključeve',
                                              command=button_generate_keys_encrypt_click)
    button_generate_keys_encrypt.grid(row=row, column=0, padx=10, pady=5)

    button_store_keys_encrypt = ttk.Button(tab3, text='Spremi ključeve', command=button_store_keys_encrypt_click)
    button_store_keys_encrypt.grid(row=row, column=1, padx=10, pady=5)

    button_load_public_key_encrypt = ttk.Button(tab3, text='Učitaj javni ključ:',
                                                command=button_load_public_key_encrypt_click)
    button_load_public_key_encrypt.grid(row=row, column=2, padx=10, pady=5)

    row += 1
    label_private_key_encrypt = tk.Label(tab3, text='Privatni ključ:')
    label_private_key_encrypt.grid(row=row, column=0, padx=10, pady=5)

    textbox_private_key_encrypt = tk.Text(tab3, height=8, width=textbox_width)
    textbox_private_key_encrypt.insert("1.0", "")
    textbox_private_key_encrypt.config(state='disabled')
    textbox_private_key_encrypt.grid(row=row, column=1, columnspan=2, padx=10, pady=5)

    row += 1
    label_public_key_encrypt = tk.Label(tab3, text='Javni ključ:')
    label_public_key_encrypt.grid(row=row, column=0, padx=10, pady=5)

    textbox_public_key_encrypt = tk.Text(tab3, height=8, width=textbox_width)
    textbox_public_key_encrypt.insert("1.0", "")
    textbox_public_key_encrypt.config(state='disabled')
    textbox_public_key_encrypt.grid(row=row, column=1, columnspan=2, padx=10, pady=5)

    row += 1
    label_set_hash_encrypt = tk.Label(tab3, text='Odaberi hash funkciju:')
    label_set_hash_encrypt.grid(row=row, column=1, padx=10, pady=5)

    options = ["SHA224", "SHA256", "SHA384", "SHA512", "SHA3_224", "SHA3_256", "SHA3_384", "SHA3_512"]
    selected_option_hash_encrypt = tk.StringVar(value=options[0])  # Variable to store selected option
    option_menu_hash_encrypt = tk.OptionMenu(tab3, selected_option_hash_encrypt, *options,
                                             command=option_menu_hash_select_encrypt)
    option_menu_hash_encrypt.grid(row=row, column=2, padx=10, pady=5)

    row += 1
    button_load_message_encrypt = ttk.Button(tab3, text='Učitaj poruku', command=button_load_message_encrypt_click)
    button_load_message_encrypt.grid(row=5, column=2, padx=10, pady=5)

    row += 1
    label_message_encrypt = tk.Label(tab3, text='Poruka:')
    label_message_encrypt.grid(row=row, column=0, padx=10, pady=5)

    textbox_message_encrypt = tk.Text(tab3, height=2, width=textbox_width)
    textbox_message_encrypt.insert("1.0", "")
    textbox_message_encrypt.grid(row=row, column=1, columnspan=2, padx=10, pady=5)

    row += 1
    button_encrypt = ttk.Button(tab3, text='Šifriraj', command=button_encrypt_click)
    button_encrypt.grid(row=row, column=1, padx=10, pady=5)

    row += 1
    label_encrypted = tk.Label(tab3, text='')
    label_encrypted.grid(row=row, column=1, padx=10, pady=5)

    # Tab 4
    row = 0
    button_load_encrypt = ttk.Button(tab4, text='Učitaj šifriranu datoteku', command=button_load_encrypt_click)
    button_load_encrypt.grid(row=row, column=2, padx=10, pady=5)

    row += 1
    label_load_encrypted = tk.Label(tab4, text='Šifrirana poruka:')
    label_load_encrypted.grid(row=row, column=0, padx=10, pady=5)

    textbox_load_encrypted = tk.Text(tab4, height=1, width=textbox_width)
    textbox_load_encrypted.insert("1.0", "")
    textbox_load_encrypted.config(state='disabled')
    textbox_load_encrypted.grid(row=row, column=1, columnspan=2, padx=10, pady=5)

    row += 1
    label_set_hash_decrypt = tk.Label(tab4, text='Odaberi hash funkciju:')
    label_set_hash_decrypt.grid(row=row, column=1, padx=10, pady=5)

    options = ["SHA224", "SHA256", "SHA384", "SHA512", "SHA3_224", "SHA3_256", "SHA3_384", "SHA3_512"]
    selected_option_hash_decrypt = tk.StringVar(value=options[0])  # Variable to store selected option
    option_menu_hash_decrypt = tk.OptionMenu(tab4, selected_option_hash_decrypt, *options,
                                             command=option_menu_hash_select_decrypt)
    option_menu_hash_decrypt.grid(row=row, column=2, padx=10, pady=5)

    row += 1

    button_load_private_key_decrypt = ttk.Button(tab4, text='Load private key',
                                                 command=button_private_key_decrypts_click)
    button_load_private_key_decrypt.grid(row=row, column=2, padx=10, pady=5)

    row += 1
    label_private_key = tk.Label(tab4, text='Privatni ključ:')
    label_private_key.grid(row=row, column=0, padx=10, pady=5)

    textbox_private_key_decrypt = tk.Text(tab4, height=8, width=textbox_width)
    textbox_private_key_decrypt.insert("1.0", "")
    textbox_private_key_decrypt.config(state='disabled')
    textbox_private_key_decrypt.grid(row=row, column=1, columnspan=2, padx=10, pady=5)

    row += 1
    button_decrypt = ttk.Button(tab4, text='Dešifriraj', command=button_decrypt_click)
    button_decrypt.grid(row=row, column=1, padx=10, pady=5)

    row += 1
    label_decrypted = tk.Label(tab4, text='Dešifrirana poruka: ')
    label_decrypted.grid(row=row, column=0, padx=10, pady=5)

    textbox_decrypted = tk.Text(tab4, height=2, width=textbox_width)
    textbox_decrypted.insert("1.0", "")
    textbox_decrypted.config(state='disabled')
    textbox_decrypted.grid(row=row, column=1, columnspan=2, padx=10, pady=5)

    tab_control.bind("<<NotebookTabChanged>>", on_tab_selected)

    tab_control.pack(expand=1, fill="both")

    root.mainloop()

